
/*
 *    MCreator note: This file will be REGENERATED on each build.
 */
package net.mcreator.vibraniumandneutronium.init;

import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.event.world.BiomeLoadingEvent;
import net.minecraftforge.event.RegistryEvent;

import net.minecraft.world.level.levelgen.feature.Feature;
import net.minecraft.world.level.levelgen.feature.ConfiguredFeature;
import net.minecraft.world.level.levelgen.GenerationStep;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.data.BuiltinRegistries;
import net.minecraft.core.Registry;

import net.mcreator.vibraniumandneutronium.world.features.ores.VibraniumFeature;
import net.mcreator.vibraniumandneutronium.world.features.ores.RtshFeature;
import net.mcreator.vibraniumandneutronium.world.features.ores.GregFeature;
import net.mcreator.vibraniumandneutronium.world.features.ores.EfojiFeature;
import net.mcreator.vibraniumandneutronium.world.features.RudavibraniumFeature;
import net.mcreator.vibraniumandneutronium.world.features.EwrrrrrFeature;

import java.util.Set;
import java.util.Map;
import java.util.HashMap;

@Mod.EventBusSubscriber(bus = Mod.EventBusSubscriber.Bus.MOD)
public class VibraniumAndNeutroniumModFeatures {
	private static final Map<Feature<?>, FeatureRegistration> REGISTRY = new HashMap<>();
	static {
		REGISTRY.put(VibraniumFeature.FEATURE, new FeatureRegistration(GenerationStep.Decoration.UNDERGROUND_ORES, VibraniumFeature.GENERATE_BIOMES,
				VibraniumFeature.CONFIGURED_FEATURE));
		REGISTRY.put(RudavibraniumFeature.FEATURE, new FeatureRegistration(GenerationStep.Decoration.UNDERGROUND_STRUCTURES,
				RudavibraniumFeature.GENERATE_BIOMES, RudavibraniumFeature.CONFIGURED_FEATURE));
		REGISTRY.put(GregFeature.FEATURE,
				new FeatureRegistration(GenerationStep.Decoration.UNDERGROUND_ORES, GregFeature.GENERATE_BIOMES, GregFeature.CONFIGURED_FEATURE));
		REGISTRY.put(RtshFeature.FEATURE,
				new FeatureRegistration(GenerationStep.Decoration.UNDERGROUND_ORES, RtshFeature.GENERATE_BIOMES, RtshFeature.CONFIGURED_FEATURE));
		REGISTRY.put(EfojiFeature.FEATURE,
				new FeatureRegistration(GenerationStep.Decoration.UNDERGROUND_ORES, EfojiFeature.GENERATE_BIOMES, EfojiFeature.CONFIGURED_FEATURE));
		REGISTRY.put(EwrrrrrFeature.FEATURE, new FeatureRegistration(GenerationStep.Decoration.UNDERGROUND_STRUCTURES, EwrrrrrFeature.GENERATE_BIOMES,
				EwrrrrrFeature.CONFIGURED_FEATURE));
	}

	@SubscribeEvent
	public static void registerFeature(RegistryEvent.Register<Feature<?>> event) {
		event.getRegistry().registerAll(REGISTRY.keySet().toArray(new Feature[0]));
		REGISTRY.forEach((feature, registration) -> Registry.register(BuiltinRegistries.CONFIGURED_FEATURE, feature.getRegistryName(),
				registration.configuredFeature()));
	}

	@Mod.EventBusSubscriber
	private static class BiomeFeatureLoader {
		@SubscribeEvent
		public static void addFeatureToBiomes(BiomeLoadingEvent event) {
			for (FeatureRegistration registration : REGISTRY.values()) {
				if (registration.biomes() == null || registration.biomes().contains(event.getName())) {
					event.getGeneration().getFeatures(registration.stage()).add(() -> registration.configuredFeature());
				}
			}
		}
	}

	private static record FeatureRegistration(GenerationStep.Decoration stage, Set<ResourceLocation> biomes,
			ConfiguredFeature<?, ?> configuredFeature) {
	}
}
